%_________________________________________________________________
%Nehari extension
% Made by professor Morten Hovd
Gd_uss = ss(Gd_us);
%Merk: Glovers formler for Nehari extension dekker bare kvadratiske
%systemer.M derfor tilpasse de to elementene i Gd_uns hver for seg
%ui=1 eller ui = 2)

ui = 2;
[a,b,c,d]=ssdata(Gd_uss);

b = b(:,ui);
d = d(:,ui);

%----- Tilpass koden ovenfor for evt. andre systemer

%Gds = ss(-a,-b,c,d);
Gds = ss(-a',-c',b',d');%'Mirror image of unstable part': ikke bare 
% er tiden reversert, men i tillegg m innganger og
% utganger 'byttes om', dvs. man 'sender
% utgangssignalet tilbake til inngangen'.

[Gdsb,g]=balreal(Gds);%Poler nr imaginr akse gir svrt stor Hankel 
%singulrverdi, og derfor drlig tilnrming.
[A,B,C,D]=ssdata(Gdsb);

nx = size(A,1);

I = eye(nx);
P = fliplr(I);

%Reverser rekkeflgen p tilstandene.
Ap = P*A*P';
Bp = P*B;
Cp = C*P';
Dp = D;
Gp = ss(Ap,Bp,Cp,Dp);


%Finn controllability grammian og observability grammian
P = gram(Gp,'c');
Q = gram(Gp,'o');

sig = P(nx,nx);

S1 = P(1:nx-1,1:nx-1);
S2 = Q(1:nx-1,1:nx-1);

Gam = S1*S2-eye(nx-1)*sig^2;
U = -1; 
%Eneste mulige valg for SISO systemer(?), 
%se (6.23) hos Glover for det generelle tilfellet.

A11 = Ap(1:nx-1,1:nx-1);
B1 = Bp(1:nx-1,:);
C1 = Cp(:,1:nx-1);

Ah = (Gam)\(sig^2*A11'+S2*A11*S1-sig*C1'*U*B1');
Bh = (Gam)\(S2*B1+sig*C1'*U);
Ch = C1*S1+sig*U*B1';
Dh = Dp -sig*U;

Gd_usN = ss(-Ah',-Ch',Bh',Dh')
[Ac,Bc,Cc,Dc]=ssdata(Gd_usN);
[Gdm_num,Gdm_den]=ss2tf(Ac,Bc,Cc,Dc);
Gdm_usN=tf(Gdm_num,Gdm_den)