function [ybed1]=bed1(Tin1,cf,p,T,c,m1)
%______________________Parameters__________________________________________
Cp=3500;           % gas
Cpc=1100;          % catalyst
Nbed1=10;   % No. of discretization points; 10 in each bed
rhoc=2200;
vol1=6.69;
dHrx=2.7e6; % [kJ/kg] Note: 111370 * 28 = 3.118 e6
dm1=vol1/Nbed1*rhoc;  % mass of catalyst in each bed
%__________________________________________________________________________
% Conc. in bed 1:
dcdt(1)=cf-c(1)+dm1*rx(p,T(1),cf)/m1;
for i=2:10
  dcdt(i)=c(i-1)-c(i)+dm1*rx(p,T(i),c(i-1))/m1;
end
%___________________temperature____________________________________________
%Dtdt in bed 1:
dTdt(1)=(m1*Cp*(Tin1-T(1))+dm1*rx(p,T(1),cf)*dHrx)/(dm1*Cpc);
for i=2:10
    dTdt(i)=(m1*Cp*(T(i-1)-T(i))+dm1*rx(p,T(i),c(i-1))*dHrx)/(dm1*Cpc);
end
ybed1=[dTdt dcdt];