function [ybed2]=bed2(Tin2,cin2,p,T,c,m2)
%_____________________Parameters__________________________
Cp=3500;           % gas
Cpc=1100;          % catalyst
Nbed2=10;   % No. of discretization points; 10 in each bed
rhoc=2200;
vol2=9.63;
dHrx=2.7e6; % [kJ/kg] Note: 111370 * 28 = 3.118 e6
dm2=vol2/Nbed2*rhoc;  % mass of catalyst in each bed
%__________________________________________________________
% Concentration in bed 2
dcdt(1)=cin2-c(1)+dm2*rx(p,T(1),cin2)/m2;
for i=2:10
  dcdt(i)=c(i-1)-c(i)+dm2*rx(p,T(i),c(i-1))/m2;
end
% Temperature in bed 2
dTdt(1)=(m2*Cp*(Tin2-T(1))+dm2*rx(p,T(1),cin2)*dHrx)/(dm2*Cpc);
for i=2:10
    dTdt(i)=(m2*Cp*(T(i-1)-T(i))+dm2*rx(p,T(i),c(i-1))*dHrx)/(dm2*Cpc);
end
ybed2=[dTdt dcdt];