function [ybed3]=bed3(Tin3,cin3,p,T,c,m3)
%_____________________Parameters_____________________________
Cp=3500;           % gas
Cpc=1100;          % catalyst
Nbed3=10;   % No. of discretization points; 10 in each bed
rhoc=2200;
vol3=15.2;
dHrx=2.7e6; % [kJ/kg] Note: 111370 * 28 = 3.118 e6
dm3=vol3/Nbed3*rhoc;  % mass of catalyst in bed 3
%______________________________________________________________
% Concentration in bed 3
dcdt(1)=cin3-c(1)+dm3*rx(p,T(1),cin3)/m3;
for i=2:10
    dcdt(i)=c(i-1)-c(i)+dm3*rx(p,T(i),c(i-1))/m3;
end
%____________________ Temperature______________________________
dTdt(1)=(m3*Cp*(Tin3-T(1))+dm3*rx(p,T(1),cin3)*dHrx)/(dm3*Cpc);
for i=2:10
    dTdt(i)=(m3*Cp*(T(i-1)-T(i))+dm3*rx(p,T(i),c(i-1))*dHrx)/(dm3*Cpc);
end
ybed3=[dTdt dcdt];