global mc mh Cp Cpc Q1 Q2 Q3 Npoint Tfeed cf dm1 dm2 dm3 dHrx u conc p c
c=0.08*ones(1,30);
mc=127*1000/3600;  % flow entering heat exchanger (kg/s)
mh=252*1000/3600;  % total feed flow (kg/s)
Cp=3500;           % gas
Cpc=1100;          % catalyst
Q1=58*1000/3600;   % quench flows (kg/s)
Q2=35*1000/3600;
Q3=32*1000/3600;
Npoint=30;         % No. of discretization points; 10 in each bed
cf=0.08;  % feed mass fraction of ammonia
rhoc=2200;
vol1=6.69;
vol2=9.63;
vol3=15.2;
dHrx=2.7e6; % [kJ/kg] Note: 111370 * 28 = 3.118 e6
dm1=vol1/Npoint*3*rhoc;  % mass of catalyst in each bed
dm2=vol2/Npoint*3*rhoc;
dm3=vol3/Npoint*3*rhoc;
fcorr=0.5; epsnr=1.e-4;   % decrease fcorr if convergense problems
p = 200;         % Reactor pressure, bar
Tfeed=224;          % Fresh feed temperature, C
% _________________________________________________________________________


%__________________________________________________________________________
%                           Steady-state
%__________________________________________________________________________
%Taken from Morud(1997), Tinit determines which steady state you will find
%Tinit=linspace(340,460,30); % should give middle steady-state; To=437.31
Tinit=linspace(360,510,30);  % should give upper steady-state; To=511.565
Tss=ssnr(Tinit,fcorr,epsnr);
Tinit10=Tinit(1:10);
Tinit20=Tinit(11:20);
Tinit30=Tinit(21:30);
delta=0.001;
%   A-matrix with c(i)=c(i-1)+........
for i=1:Npoint
 perturb=zeros(Npoint,1);
 perturb(i)=delta;
 pert1 = righthand(0,Tss+perturb')';
 pert2 = righthand(0,Tss-perturb')';
 A(:,i)=( pert1 - pert2 )/(2*delta);
end
%_____________________________Eigenvalues__________________________________
%Tfeed=250 (constant)
%Tfeed[crit]=232
% p=170: Barely unstable with eigenvalues 0.0002+- 0.0148i
        %        where 1/0.0148 = 67.5 sec
        %        Limit of instability is at about 172 bar.
% p=200: Stable; eigenvalues furthest to right -0.0017+- 0.0183i
% p=165: Unstable with eigenvalues 0.0007 +- 0.0143i where 

%__________________________________________________________________________
% p=200 (constant)
% p[crit]=172 bar
% Tfeed=250:    Stable; eigenvalues furthest to right -0.0017 +- 0.0183i
% Tfeed=240:    Stable; eigenvalues furthest to right -0.0006 +- 0.0167i
% Tfeed=230:    Barely unstable with eigenvalues 0.0010 +- 0.0142i
%__________________________________________________________________________
% B-,C- and D-matrices
u=heatx(Tinit(Npoint),Tfeed);
u0=u;
u=u0-delta; delT1=righthopen(Tinit);
u=u0+delta; delT2=righthopen(Tinit);
u=u0;
B=(delT2-delT1)'/(2*delta); B(2:Npoint)=0*B(2:Npoint);
C=zeros(1,Npoint);  C(Npoint)=1; 
%only the reactor outlet temperature is available for measurement 
D=[0];
d=[0 0];
%------------------------------------------------------------------
%                           G(s)
%------------------------------------------------------------------
[num,den]=ss2tf(A,B,C,D);
G=tf(num,den);
zs=zero(G);
ps=pole(G)
[z1,p1,k1]=tf2zp(num,den);
[G_s,G_us]=stabsep(G);
%__________________________________________________________________
%                   Disturbance model
%___________________________________________________________________
Bd_p=200*ones(30,1); Bd_p(1)=0; Bd_p(10)=10;Bd_p(20)=0;
Bd_Tf=zeros(30,1);Bd_Tf(1)=250;Bd_Tf(10)=250;Bd_Tf(20)=250;
Bd=[Bd_p Bd_Tf];
Dsys=ss(A,Bd,C,d);
Gd=tf(Dsys);set(Gd,'InputName',{'Pressure';'Tfeed'},'Outputname','To');
zd=zero(Gd);
pd=pole(Gd)
%__________________________________________________________________________
%                 Splitted disturbance model Gd
% Gd_s is the stable part of Gd
% And Gd_us is the unstable part...
% Gd_s is allways strictly proper
%__________________________________________________________________________
[Gd_s,Gd_us]=stabsep(Gd);
zd_us=zero(Gd_us);
pd_us=pole(Gd_us);
%s=tf('s');
%__________________________________________________________________________
%                   Gd_us mirrored into the LHP
%__________________________________________________________________________
% Disturbance transfer function from input "pressure" to output To
% [z1,p1,k1]=zpkdata(Gd_us(1));
% p_temp1=p1{1};
% z_temp1=z1{1};
% pm1=uminus(p_temp1);
% zm1=uminus(z_temp1);
% Gdm1=zpk(zm1,pm1,k1);
% pdm1=pole(Gdm1)
% zdm1=zero(Gdm1)
% pu1=pole(Gd_us(1))
% zu1=zero(Gd_us(1))
% Disturbance transfer function from input "Tfeed" to output To
% [z2,p2,k2]=zpkdata(Gd_us(2));
% p_temp2=p2{1};
% z_temp2=z2{1};
% pm2=uminus(p_temp2);
% zm2=uminus(z_temp2);
% Gdm2=zpk(zm2,pm2,k2);
% pdm2=pole(Gdm2)
% zdm2=zero(Gdm2)
% pu2=pole(Gd_us(2))
% zu2=zero(Gd_us(2))
% Always control the pole of Gdm, which is the mirrored image of Gd_us...
% The zeros and poles of Gdm and Gd_us should be equal, but with
% opposite sign ,i.e., the poles and zeros of Gdm should be in the LHP, when 
% the poles and zeros of Gd_us is in the RHP. Otherwise both is zero.
%__________________________________________________________________________


